//+------------------------------------------------------------------+
//|                                                                  |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                            "http://www.mql4.com/ru/users/costy_" |
//+------------------------------------------------------------------+
 
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.mql4.com/ru/users/costy_"

#define \ "\\"

#property show_inputs
extern int ___=5;
extern bool sort_max_volume=true;
 
#include <Table_costy.mq4>



string   val[], 
         Temp[], 
         Wap[]={"Spread","   $","Spr*$","    H/L","H/L"};
         
double   Spread[],
         TICKVALUE[],
         HL[],
         Spread.$[],
         Volume_max[],
         Volume_30_Day[];
         
int red_green[],kol_vo;

int init(){
 Comment("");
  kol_vo=SymbolsList(val, true);
  if(kol_vo == -1){   Alert("    SymbolsList(string &Symbols[], bool Selected)");   return(-1);}
  
  
  ArrayResize(Spread,kol_vo); ArrayResize(TICKVALUE,kol_vo);
  ArrayResize(HL,kol_vo);     ArrayResize(Spread.$,kol_vo);   ArrayResize(red_green,kol_vo);
  ArrayResize(Volume_max,kol_vo); ArrayResize(Volume_30_Day,kol_vo); 
  
  string s="\n ";
  
   for(int v=0;v<kol_vo;v++){
     Spread[v]=MarketInfo(val[v],MODE_SPREAD);
     TICKVALUE[v]=MarketInfo(val[v],MODE_TICKVALUE);
     Spread.$[v]=Spread[v]*TICKVALUE[v];
     double vol_me[30];
     for(int vol=0;vol<30;vol++)
         vol_me[vol]=iVolume(val[v],0,vol);
     Volume_max[v]=vol_me[ArrayMaximum(vol_me)];
     Volume_30_Day[v]=iMAOnArray(vol_me,0,30,0,0,0);
     s=s+val[v]+" Volume_max "+Volume_max[v]+"Volume_30_Day "+Volume_30_Day[v]+"\n";
   }
  // Comment(s);
   
   
   
    int file = FileOpen(WindowExpertName()+\+sort_max_volume+".xls", FILE_CSV|FILE_WRITE|FILE_READ );
    if(file>0){
          FileSeek(file,0,SEEK_SET);
          FileWrite(file,"val"+"\t"+"Spread[j]"+"\t"+"TICKVALUE[j]"+" \t "+"Spread.$[j]"+" \t "+"Volume_max[j]"+" \t "+ "Volume_30_Day[j]");

    
       for(int j=0;j<kol_vo &&!IsStopped();j++){
          FileSeek(file,0,SEEK_END);
          FileWrite(file,val[j]+"\t"+Spread[j]+"\t"+TICKVALUE[j]+" \t "+Spread.$[j]+" \t "+Volume_max[j]+" \t "+ Volume_30_Day[j]);
       }
          FileClose(file);
    }
   
   
   
   
   
   
   
  // Sort(Spread.$,Spread,TICKVALUE,Volume_max,Volume_30_Day,val);
   for( v=0;v<kol_vo;v++){
     if(iOpen(val[v],1440,1)<iClose(val[v],1440,1))
     red_green[v]=1;
     HL[v]=0.0;
     for(int i=0;i<___;i++)
       HL[v]+=(iHigh(val[v],1440,1+i)-iLow(val[v],1440,1+i))/MarketInfo(val[v],MODE_POINT)*TICKVALUE[v];
     HL[v]/=___;
   }
   
   
   Table();
}
//--------------------------------------------------------------
void start(){
 while(!IsStopped()){Sleep(500000);}
}
//void deinit(){DeleteTable();}
//--------------------------------------------------------------

//+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=
//  sort
//+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=

void Sort(double &buf1[],double &buf2[],double &buf3[],double &buf4[],double &buf5[],string &buf_str1[]){
   int size=ArraySize(buf1);
   double dou_temp1[]; ArrayResize(dou_temp1,size);
   double dou_temp2[]; ArrayResize(dou_temp2,size);
   double dou_temp3[]; ArrayResize(dou_temp3,size);
   double dou_temp4[]; ArrayResize(dou_temp4,size);
   double dou_temp5[]; ArrayResize(dou_temp5,size);
   string str_temp1[]; ArrayResize(str_temp1,size);
   
   for(int i=0;i<size;i++){
    dou_temp1[i]=buf1[i];
    dou_temp2[i]=buf2[i];
    dou_temp3[i]=buf3[i];
    dou_temp4[i]=buf4[i];
    dou_temp5[i]=buf5[i];
    str_temp1[i]=buf_str1[i];
   }
   if(sort_max_volume){
      ArraySort(dou_temp4,size,0,MODE_DESCEND);

      for( i=0;i<size;i++)
      for(int j=0;j<size;j++)
         if(dou_temp4[i]==buf4[j]){
            buf4[i]=-1.0;
            buf1[i]=dou_temp1[j];
            buf2[i]=dou_temp2[j];
            buf3[i]=dou_temp3[j];
            buf5[i]=dou_temp5[j];
            buf_str1[i]=str_temp1[j];
            break;
         }
      for( i=0;i<size;i++)
      buf4[i]=dou_temp4[i];  
   } else {
      ArraySort(dou_temp5,size,0,MODE_DESCEND);

      for( i=0;i<size;i++)
      for( j=0;j<size;j++)
         if(dou_temp5[i]==buf5[j]){
            buf5[i]=0.0;
            buf1[i]=dou_temp1[j];
            buf2[i]=dou_temp2[j];
            buf3[i]=dou_temp3[j];
            buf4[i]=dou_temp4[j];
            buf_str1[i]=str_temp1[j];
            break;
         }
      for( i=0;i<size;i++)
      buf4[i]=dou_temp4[i];  
   
   }

}






//+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=
//  Table
//+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=
void Table(){

  CreateWap(Wap,Green); // 
  
  // 1
  CreateTable(0,ArraySize(val),val,red_green);
  //2
  DoubleToStr_buf(Spread,Temp,0);
  CreateTable(1,ArraySize(Temp),Temp,red_green);
  //3
  DoubleToStr_buf(TICKVALUE,Temp,0);
  CreateTable(2,ArraySize(Temp),Temp,red_green);
  //4
  DoubleToStr_buf(Spread.$,Temp,0);
  CreateTable(3,ArraySize(Temp),Temp,red_green);
  //5
  DoubleToStr_buf(HL,Temp,0);
  CreateTable(4,ArraySize(Temp),Temp,red_green);
  //6
  DoubleToStr_buf(Volume_max,Temp,0);
  CreateTable(6,ArraySize(Temp),Temp,red_green);
  //7
  DoubleToStr_buf(Volume_30_Day,Temp,0);
  CreateTable(9,ArraySize(Temp),Temp,red_green);
}







//+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=
//       .. 
//+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=
int SymbolsList(string &Symbols[], bool Selected){ 
   int Offset, SymbolsNumber; string SymbolsFileName;    
   if(Selected) SymbolsFileName = "symbols.sel";   else         SymbolsFileName = "symbols.raw";   
   int hFile = FileOpenHistory(SymbolsFileName, FILE_BIN|FILE_READ);   
   if(hFile < 0) return(-1);   if(Selected) { SymbolsNumber = (FileSize(hFile) - 4) / 128; Offset = 116;  }   
    else   { SymbolsNumber = FileSize(hFile) / 1936;      Offset = 1924; }   
   ArrayResize(Symbols, SymbolsNumber);   
   if(Selected) FileSeek(hFile, 4, SEEK_SET);   
   for(int i = 0; i < SymbolsNumber; i++){Symbols[i] = FileReadString(hFile, 12); FileSeek(hFile, Offset, SEEK_CUR);} 
   FileClose(hFile);   
 return(SymbolsNumber);
}