//+------------------------------------------------------------------+
//|                                                  Table_costy.mq4 |
//|                                                              I_D |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "_costy"
#property link      "http://"
#property library

//=====================================================================
//	 :
//=====================================================================
#define ROWS			30	//     
#define COLUMNS			80	//     
  int Xdist[]={12,80,120,160,200,240,280,320,360,400,440,480,520,560,600,640,680,720,760,800};

//--------------------------------------------------------------
void CreateTable(int ,string price_Spread[],color colore){
 for(int l=0;l<=30;l++){
    string name= +"_name_"+l;
    if(ObjectFind(name)!=-1)
        ObjectDelete(name);
 } 

 if(ObjectFind(+"_name_7")==-1)
 for( l=0;l<ArraySize(price_Spread);l++){
  name= +"_name_"+l;
  ObjectCreate(name,OBJ_LABEL,0,0,0);
  ObjectSet(name,OBJPROP_XDISTANCE,Xdist[]);
  ObjectSet(name,OBJPROP_YDISTANCE,36+l*20);
  ObjectSetText(name,price_Spread[l]);
  ObjectSet(name,OBJPROP_COLOR,colore);
  WindowRedraw( ) ;
 } 
}
//--------------------------------------------------------------
void CreateWap(string buf[],color colore){
 for(int l=1;l<=ArraySize(buf);l++){
  string name= "name_"+l;
  if(ObjectFind(name)==-1){
    ObjectCreate(name,OBJ_LABEL,0,0,0);
    ObjectSet(name,OBJPROP_XDISTANCE,Xdist[l]-8);
    ObjectSet(name,OBJPROP_YDISTANCE,12);
    ObjectSetText(name,buf[l-1]);
    ObjectSet(name,OBJPROP_COLOR,colore);
    ObjectSet(name,OBJPROP_FONTSIZE,10);
   }
 } 
  WindowRedraw( ) ;
}
//--------------------------------------------------------------



void DoubleToStr_buf(double buf_in[],string &buf_out[],int digits){
 ArrayResize(buf_out,ArraySize(buf_in));
 for(int l=0;l<ArraySize(buf_in);l++)
  buf_out[l]=DoubleToStr(buf_in[l],digits);
}
//--------------------------------------------------------------
void DeleteTable(){
 for(int l=0;l<ROWS;l++){
  if(ObjectFind("name_"+l)!=-1) ObjectDelete("name_"+l);
 }
 for(int i=0;i<ROWS;i++)
 for( l=0;l<COLUMNS;l++){
  if(ObjectFind(l+"_name_"+i)!=-1) ObjectDelete(l+"_name_"+i);
 }
  WindowRedraw( ) ;
}